import { request } from '@wisdom-utils/utils/es';

const { REACT_APP_ENV } = process.env;
// 流程列表

/** @Tips: 新版接口，逐步替换老版接口 2021年12月1日 */
const BASE = '/PandaWorkFlow/WorkFlow';
const BASEURL = '/PandaWorkFlow/WorkFlow/AccountManage';
const YOURSELFER_SERVER = 'http://127.0.0.1:8181';
const url = (REACT_APP_ENV || 'dev') !== 'dev' ? `${YOURSELFER_SERVER}/${BASEURL}` : `${window.location.origin}${BASEURL}`;// 新版的链接
/** @End */

/** @Tips: 增加空值检测 */
const NOTHING = [undefined, '', null, void 0]; // void 0 === void 1
/** @End */

// 选择器选项的值查询
/** @Tips: web4版本接口  */

/*export function getSelectName(nodeName) {
  return request({
    url: `${requestIP}/WorkFlow`,
    method: 'get',
  });
}*/
// 获取字典的接口
export function getSelectName(nodeName) {
  return request({
    url: `${BASEURL}/GetSelectItemList?nodeName=${nodeName}`,
    method: 'get',
  });
}

// 选择器选项的子节点查询
/** @Tips: web4版本接口 */

/* export function getSelectChildName(nodeName) {
  return request({
    url: `${requestIP}/WorkChildFlow`,
    method: 'get',
  });
} */
export function getSelectChildName(nodeName) {
  return request({
    url: `${BASEURL}/WorkChildFlow`,
    method: 'get',
  });
}

// 站点选择器查询
/** @Tips: web4版本接口 */

/*export function getStationListByUserID(name) {
  return request({
    url: `${requestIP}/GetStationListByUserID`,
    method: 'get',
  });
}*/
export function getStationListByUserID(id, sysType, isAll) {
  return request({
    url: `/PandaWorkFlow/WorkFlow/WorkFlow/GetStationListByUserID?userID=${id}${!NOTHING.includes(sysType) ? '&sysType=' + sysType : ''}${!NOTHING.includes(sysType) ? '&isAll=' + isAll : ''}`,
    method: 'get',
  });
}

// 人员选择器查询
/** @Tips: web4版本接口 */

/* export function getUserListForRole() {
  return request({
    url: `${requestIP}/GetUserListForRole`,
    method: 'get',
  });
} */
export function getUserListForRole() {
  return request({
    url: `${BASEURL}/GetUserListForRole`,
    method: 'get',
  });
}

//人员选择器_下拉框
export const getMenTreeByRole = (paramas) => {
  const { role, userID } = paramas
  return request({
    url: `${BASE}/WorkFlow/GetMenTreeByRole?userID=${userID}&role=${role}`,
    method: 'get',
  })
}

//部门选择器
export const getDeptList = (params) => {
  return request({
    url: `${BASEURL}/GetDeptList`,
    method: 'post',
  })
}

// 台账的配置查询
/*export function GetAccountConfigInfo(accountName) {
  return request({
    url: `${requestIP}/GetAccountConfigInfo`,
    method: 'get',
  });
}*/
export function GetAccountConfigInfo(accountName) {
  return request({
    url: `${BASEURL}/GetAccountConfigInfo?accountName=${accountName}`,
    method: 'get',
  });
}

// 台账的表查询
/*export function GetAccountPageList(pageIndex, pageSize, accountName, info) {
  return request({
    url: `${requestIP}/GetAccountPageList`,
    method: 'get',
  });
}*/
export function GetAccountPageList(data) {
  return request({
    url: `${BASEURL}/GetAccountPageList`,
    method: 'post',
    data,
  });
}

export function GetTableGroupMeta(accountName) {
  return request({
    url: `${BASEURL}/GetTableGroupMeta?accountName=${accountName}`,
    method: 'get'
  });
}

// 业务选择器查询
/*export function GetFieldValueFromTable(pageIndex, pageSize, accountName, info) {
  return request({
    url: `${requestIP}/GetFieldValueFromTable`,
    method: 'get',
  });
}*/

// NEXT需要增加分页
export function GetFieldValueFromTable(accountName, fieldName, filter) {
  return request({
    url: `${BASEURL}/GetFieldValueFromTable?tableName=${accountName}&fieldName=${fieldName}${filter ? '&filter=' + filter : ''}`,
    method: 'get',
  });
}

// 台账表单的提交
/*export function SubmitAccountData(tableName, key, value, data) {
  return request({
    url: `${requestIP}/EditTableData?tableName=${tableName}&key=${key}&id=${value}`,
    method: 'post',
    data: data,
  });
}*/
export function SubmitAccountData(tableName, key, value, data) {
  return request({
    url: `${BASEURL}/EditTableData?tableName=${tableName}&key=${key}&id=${value}`,
    method: 'post',
    data: data,
  });
}

// 台账的新增
/*export function AddNewAccountData(data) {
  return request({
    url: `${requestIP}/`,
    method: 'post',
    data,
  });
}*/
export function AddNewAccountData(data) {
  return request({
    url: `${BASEURL}/`,
    method: 'post',
    data,
  });
}

/** @Tips: 新版接口，逐步替换老版接口 2021年12月1日 */
// 上传文件
export function UploadFileReturnUrl(data) {
  return request({
    url: `${url}/UploaderFiles`,
    method: 'post',
    data,
  });
}

export function downloadFile(str) {
  return request({
    url: `${url}/DownloadFiles?filePath=${str}`,
    method: 'get',
  });
}

export const uploadFileUrl = `${BASEURL}/UploaderFiles`; // 上传文件链接
export const downloadFileUrl = `${BASEURL}/DownloadFiles`; // 下载/播放文件链接
/** @End */

/**
 *  @Description: 获取单条数据，使用JsonToHtml去编译
 *  @Date: 2021/9/29
 *  @Author: ChenLong
 *  @Params tableName: 需要查询的表名；includeFields：需要的字段名；id：记录id
 * */

export function GetTableDataInfo({ accountName, id }) {
  return request({
    url: `${BASEURL}/GetTableDataInfo?accountName=${accountName}&id=${id}`,
    method: 'GET',
  });
}

/**
 *  @Description: 保存单条数据，使用JsonToHtml去编译
 *  @Date: 2021/11/1
 *  @Author: tianxiang
 *  @Params tableName，values
 * */

export function SaveTableDataInfo(data) {
  return request({
    url: `${BASEURL}/SaveTableDataInfo`,
    method: 'post',
    data,
  });
}

/**
 *  @Description: 保存单条数据，使用JsonToHtml去编译
 *  @Date: 2021/11/1
 *  @Author: tianxiang
 *  @Params tableName，values
 * */

export function EditTableDataInfo(data) {
  return request({
    url: `${BASEURL}/EditTableDataInfo`,
    method: 'post',
    data,
  });
}

export function DeleteTableDataInfo(data) {
  return request({
    url: `${BASEURL}/DeleteTableDataInfo`,
    method: 'post',
    data,
  });
}