const baseSettings = {
  title: {
    title: '标题',
    type: 'string',
    // widget: 'htmlInput',
    displayType: 'row',
    labelWidth: 80,
  },
}

const commonSettings = {
  $id: {
    title: '字段名称',
    type: 'string',
    widget: 'FieldNames',
    required: true,
    displayType: 'row',
    labelWidth: 80,
    // width: '70%',
  },
  title: {
    title: '标题',
    required: true,
    type: 'string',
    widget: 'htmlInput',
    displayType: 'row',
    labelWidth: 80,
  },
  placeholder: {
    title: '提示语',
    type: 'string',
    displayType: 'row',
    labelWidth: 80,
  },
  // description: {
  //   title: '说明',
  //   type: 'string',
  // },
  presetValue: {
    title: '默认值',
    type: 'string',
    displayType: 'row',
    labelWidth: 80,
    // default: ''
  },
}

const switchSettings = {
  disabled: {
    title: '只读',
    type: 'boolean',
    widget: 'BooleanSwitch',
    displayType: 'row',
    labelWidth: 80,
    default: false
  },
  required: {
    title: '必填',
    type: 'boolean',
    widget: 'BooleanSwitch',
    displayType: 'row',
    labelWidth: 80,
    default: false
  },
  hidden: {
    title: '隐藏',
    type: 'boolean',
    widget: 'BooleanSwitch',
    default: false,
    displayType: 'row',
    labelWidth: 80,
  },
}

const elementSettings = {
  width: {
    title: '元素宽度',
    type: 'string',
    widget: 'percentSlider',
    // default: '33%',
  },
  labelWidth: {
    title: '标签宽度',
    description: '默认值110',
    default: 110,
    type: 'number',
    widget: 'slider',
    max: 400,
    props: {
      hideNumber: true,
    },
  },
}

const allSetting = {
  ...commonSettings,
  ...switchSettings,
  ...elementSettings
}

const settings = [
  {
    title: '布局类',
    widgets: [
      {
        text: '分组名称',
        name: '分组名称',
        schema: {
          title: '分组名称',
          type: 'object',
          properties: {}
        },
        setting: {
          hidden: {
            title: '隐藏',
            type: 'boolean',
            widget: 'BooleanSwitch',
            default: false,
            displayType: 'row',
            labelWidth: 80,
          },
        },
      },
    ],
  },
  {
    title: '文本类',
    widgets: [
      {
        text: '文本',
        name: '文本',
        schema: {
          title: '文本',
          type: 'string',
          widget: 'TextInput',
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '唯一值文本',
        name: '唯一值文本',
        schema: {
          title: '唯一值文本',
          type: 'string',
          widget: 'UniqueValue'
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '多行文本',
        name: '多行文本',
        schema: {
          title: '多行文本',
          type: 'string',
          widget: 'TextArea'
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '数值',
        name: '数值',
        schema: {
          title: '数值',
          type: 'number',
          widget: 'NumberInput'
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '本人部门',
        name: '本人部门',
        schema: {
          title: '本人部门',
          type: 'string',
          name: '本人部门',
          widget: 'SelfInfo'
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '本人姓名',
        name: '本人姓名',
        schema: {
          title: '本人姓名',
          name: '本人姓名',
          type: 'string',
          widget: 'SelfInfo'
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '本人ID',
        name: '本人ID',
        schema: {
          title: '本人ID',
          name: '本人ID',
          type: 'string',
          widget: 'SelfInfo'
        },
        setting: {
          ...allSetting
        },
      },
      {
        text: '富文本',
        name: '富文本',
        schema: {
          title: '富文本',
          name: '富文本',
          type: 'string',
          widget: 'RichText'
        },
        setting: {
          ...allSetting
        },
      },
    ],
  },
  {
    title: '选择器类',
    widgets: [
      {
        text: '值选择器',
        name: '值选择器',
        schema: {
          title: '值选择器',
          name: '值选择器',
          type: 'string',
          widget: 'ValueSelect',
          require: true,
        },
        setting: {
          ...commonSettings,
          options: {
            title: '可选值',
            type: 'string',
            widget: 'EnumOptions',
            displayType: 'row',
            labelWidth: 80,
          },
          isMultiple: {
            title: '是否多选',
            type: 'boolean',
            widget: 'BooleanSwitch',
            displayType: 'row',
            labelWidth: 80,
          },
          ...switchSettings,
          ...elementSettings,
        }
      },
      {
        text: '平铺值选择器',
        name: '平铺值选择器',
        schema: {
          title: '平铺值选择器',
          name: '平铺值选择器',
          type: 'string',
          widget: 'TileSelect',
          require: true,
        },
        setting: {
          ...commonSettings,
          options: {
            title: '可选值',
            type: 'string',
            widget: 'EnumOptions',
            displayType: 'row',
            labelWidth: 80,
          },
          isMultiple: {
            title: '是否多选',
            name: '是否多选',
            type: 'boolean',
            widget: 'BooleanSwitch',
            displayType: 'row',
            labelWidth: 80,
          },
          ...switchSettings,
          ...elementSettings,
        }
      },
      {
        text: '搜索选择器',
        name: '搜索选择器',
        schema: {
          title: '搜索选择器',
          name: '搜索选择器',
          type: 'string',
          widget: 'SearchSelect',
          require: true,
        },
        setting: {
          ...commonSettings,
          options: {
            title: '数据字典',
            type: 'string',
            widget: 'input',
            displayType: 'row',
            labelWidth: 80,
          },
          isMultiple: {
            title: '是否多选',
            name: '是否多选',
            type: 'boolean',
            widget: 'BooleanSwitch',
            displayType: 'row',
            labelWidth: 80,
          },
          ...switchSettings,
          ...elementSettings,
        }
      },
      {
        text: '关联选择器',
        name: '关联选择器',
        schema: {
          title: '关联选择器',
          name: '关联选择器',
          type: 'string',
          widget: 'CascadeSelect',
          require: true,
        },
        setting: {
          ...commonSettings,
          dependencies: {
            title: '关联字段',
            type: 'array',
            widget: 'CascadeField',
            displayType: 'row',
            labelWidth: 80,
          },
          // isMultiple: {
          //   title: '是否多选',
          //   type: 'boolean',
          //   widget: 'BooleanSwitch',
          //   displayType: 'row',
          //   labelWidth: 80,
          // },
          ...switchSettings,
          ...elementSettings,
        }
      },
      {
        text: '人员选择器',
        name: '人员选择器',
        schema: {
          title: '人员选择器',
          name: '人员选择器',
          type: 'string',
          widget: 'PersonSelect',
          require: true,
        },
        setting: {
          ...commonSettings,
          interaction: {
            title: '交互方式',
            type: 'string',
            enum: ['下拉框', '分组模态', '树形模态'],
            default: '下拉框',
            enumNames: ['下拉框', '分组模态', '树形模态'],
            displayType: 'row',
            labelWidth: 80,
          },
          role: {
            title: '机构角色',
            type: 'string',
            required: true,
            // enum: ['下拉框', '分组模态', '树形模态'],
            // default: '下拉框',
            // enumNames: ['下拉框', '分组模态', '树形模态'],
            displayType: 'row',
            labelWidth: 80,
          },
          isMultiple: {
            title: '是否多选',
            type: 'boolean',
            widget: 'BooleanSwitch',
            displayType: 'row',
            labelWidth: 80,
          },
          ...switchSettings,
          ...elementSettings,
        }
      },
    ],
  },
  {
    title: '时间类',
    show: true,
    useCommon: true,
    widgets: [
      {
        text: '日期选择',
        name: '日期选择',
        schema: {
          title: '日期选择',
          type: 'string',
          widget: 'DateTime',
        },
        setting: {
          ...commonSettings,
          presetValue: {
            title: '默认值',
            type: 'string',
            displayType: 'row',
            labelWidth: 80,
            widget: 'date',
          },
          format: {
            title: '日期格式',
            type: 'string',
            enum: ['date', 'dateTime', 'year', 'month', 'quarter', 'week'],
            default: 'date',
            enumNames: ['日期', '日期时间', '日期年份', '日期月份', '日期季度', '日期周'],
            displayType: 'row',
            labelWidth: 80,
          },
          ...switchSettings,
          ...elementSettings,
        },
      },
      {
        text: '时间选择',
        name: '时间选择',
        schema: {
          title: '时间选择',
          type: 'string',
          widget: 'Time',
          format: 'time',
        },
        setting: {
          ...commonSettings,
          presetValue: {
            title: '默认值',
            type: 'string',
            widget: 'time',
            format: 'time',
            displayType: 'row',
            labelWidth: 80,
          },
          ...switchSettings,
          ...elementSettings,
        },
      },
    ],
  },
  {
    title: '附件类',
    show: true,
    useCommon: true,
    widgets: [
      {
        text: '附件',
        name: '附件',
        schema: {
          title: '附件',
          type: 'string',
          widget: 'FileUpload',
        },
      },
      {
        text: '图片',
        name: '图片',
        schema: {
          title: '图片',
          type: 'string',
          widget: 'FileUpload',
        },
      },
      {
        text: '录音',
        name: '录音',
        schema: {
          title: '录音',
          type: 'string',
          widget: 'FileUpload',
        },
      },
      {
        text: '视频',
        name: '视频',
        schema: {
          title: '视频',
          type: 'string',
          widget: 'FileUpload',
        },
      },
    ],
  },
  {
    title: '地图类',
    show: true,
    useCommon: true,
    widgets: [
      {
        text: '坐标控件',
        name: '坐标控件',
        schema: {
          title: '坐标控件',
          type: 'string',
          widget: 'DateSelect',
        },
      },
    ],
  },
]

const globalSettings = {
  type: 'object',
  properties: {
    column: {
      title: '整体布局',
      type: 'number',
      enum: [1],
      default: 1,
      enumNames: ['一行一列'],
      widget: 'select',
      props: {
        placeholder: '默认一行一列',
      },
      displayType: 'row',
      labelWidth: 100,
    },
    displayType: {
      title: '标签展示模式',
      type: 'string',
      default: 'row',
      enum: ['row', 'column'],
      enumNames: ['同行', '单独一行'],
      widget: 'select',
      displayType: 'row',
      labelWidth: 100,
    },
    labelWidth: {
      title: '标签宽度',
      type: 'number',
      widget: 'slider',
      max: 300,
      default: 120,
      props: {
        hideNumber: true,
      },
    },
  },
}

export {
  settings,
  baseSettings,
  commonSettings,
  globalSettings
}