import React, { useRef, useMemo, useState, useContext } from 'react'
import { ConfigProvider, message } from 'antd'
import Generator from 'fr-generator'
import { settings, baseSettings, globalSettings } from './config'
import widgets from '../widgets'

const FormDesigner = (props) => {

  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('parse-form')
  const prefixClsWithoutParseForm = getPrefixCls()
  const ref = useRef(null)

  const extraButtons = [
    {
      text: '提交',
      onClick: (value) => {
        const errors = ref.current.getErrorFields()
        if (errors.length) {
          return message.error('请按照提示完善表单内容')
        }
      }
    }
  ]

  const getId = (value) => {
    // console.log('value', value)
    return value
  }

  const onChange = (value) => {
    // console.log('value', value)
  }

  const onSchemaChange = (value) => {
    // console.log('value', value)
    return value
  }

  const onCanvasSelect = (schema) => {
    // setWidget(schema.widget)
    // console.log('value', value)
  }

  return (
    <div className={prefixCls}>
      <Generator
        configProvider={{ prefixCls: prefixClsWithoutParseForm }}
        // getId={name => name ? `${name}_${count++}` : null}
        mapping={{
          object: 'Header',
        }}
        validation={true}
        ref={ref}
        extraButtons={extraButtons}
        onChange={onChange}
        onSchemaChange={onSchemaChange}
        widgets={widgets}
        onCanvasSelect={onCanvasSelect}
        settings={settings}
        commonSettings={baseSettings}
        globalSettings={globalSettings}
      />
    </div>
  )

}

export default FormDesigner