// 自定义时间组件
import React, { useState, useEffect, useMemo } from 'react';
import { DatePicker, Input } from 'antd';
import { dateType, dateFormat } from '../../../../constant/constant';
import moment from 'moment';
import locale from 'antd/lib/date-picker/locale/zh_CN';

const DateTime = ({ value, onChange, schema }) => {

  console.log('schema', schema)

  const { disabled, format, presetValue, placeholder } = schema
  // console.log('schema', schema)
  // const dateTime = value || schema.default;
  // const format = schema.shape != '日期周' ? dateFormat[schema.shape] : 'YYYY-wo';

  const valueShow = useMemo(() => {
    return moment(value || presetValue)
  }, [presetValue, value])

  const disabledDate = (current) => {
    if (schema.config === '不超过当前时间') {
      return current && current > moment();
    } else {
      return false
    }
  };

  // 不超过当前时间这个配置没有意义，在moment的工具中，已经囊括了未到时间这步
  const disabledTime = (current) => {
    if (schema.config === '不超过当前时间') {
      return {
        disabledHours: () => [],
        disabledMinutes: () => [],
        disabledSeconds: () => [55, 56],
      };
    } else {
      return {}
    }
  };

  const dateChange = (date, dateStr) => {
    // console.log(val, dateVal)
    // onChange(schema.shape != '日期周' ? dateVal : (val ? moment(val).format('YYYY-MM-DD') : null))
    // onChange(moment(date._d).format('YYYY-MM-DD HH:mm:ss'))
    console.log(date, dateStr)
    onChange(date)
  }

  // useEffect(() => {
  //   onChange(dateTime);
  // }, []);

  return (
    <DatePicker
      mode={format}
      disabled={disabled}
      placeholder={placeholder}
      value={valueShow}
      onChange={dateChange}
      picker={dateType[schema.shape]}
      showTime={format === 'dateTime'}
      style={{ width: '100%' }}
      locale={locale}
      disabledDate={disabledDate}
    />
  );

};

export default DateTime
