/*
 ** 选择器，多级联动；BUT： 【当前不使用、不开发此形态控件】。
 ** create by ChenLong on 2021/12/7
 ** 功能路径：src\core\components\selectTree\selectTree.js
 ** 菜单参数列表：*变量名*(变量说明，数据类型，是否必填，取值范围)
 ** 更新日志：
 *          1. 业务梳理：【选择器】被匹配到时，实际是匹配了【台账字段.字典字段】这种类型的config；
 *          2. 需要先取【台账字段】的值，这个值，是字典的key；再之后做相应的数据逻辑即可
 *          3. 当【选择器】是多选时，选择器需要是多选，需要列出所有值
 *
 ** edit by ChenLong on 2021/12/7: *****修改内容*****
 *  TIP： 当匹配到该控件时，即为联动；单独的选择器会匹配到搜索选择器
 */
// 选择器 多级联动
import React, { useState, useEffect } from 'react';
import { getSelectName, getSelectChildName } from '../../../../apis/process';
import { TreeSelect } from 'antd';

const SelectTree = ({ value, onChange, schema }) => {
  const [treeData, setTreeData] = useState([]);
  const val = value || schema.default;
  const routeParams = schema.config;
  const genTreeNode = (parentId, id, title, isLeaf) => {
    return {
      id,
      pId: parentId,
      title,
      isLeaf,
    };
  };

  const onLoadData = treeNode => {
    return new Promise(resolve => {
      const routeArr = routeParams.split('.');
      const { id } = treeNode;
      const len = treeNode.pos.split('-');
      const clickIndex = len.length - 1;
      const treeDataList = [];
      getSelectChildName(routeArr[clickIndex]).then(res => {
        if (res.code === 0) {
          res.forEach(item => {
            if (item.PARENTID === treeNode.nodeId)
              setTreeData(treeData.concat([genTreeNode(id, item.NODEVALUE, item.NODENAME, item.ORDERID == 0)]));
          });
          resolve();
        } else {
          onChange('请求错误');
        }
      });
    });
  };

  const getFirstNode = () => {
    const arr = routeParams.split('.');
    getSelectName(arr[0]).then(res => {
      if (res.code === 0) {
        const firArr = [];
        res.forEach(item => {
          firArr.push({
            id: item.NODEVALUE,
            pId: 0,
            value: item.NODEVALUE,
            title: item.NODENAME,
            nodeId: item.NODEID,
            isLeaf: item.ORDERID == 0,
          });
        });
        setTreeData(firArr);
      } else {
        onChange('请求错误');
      }
    });
  };
  useEffect(() => {
    onChange(val);
    getFirstNode();
  }, []);
  return (
    <TreeSelect
      treeDataSimpleMode
      style={{ width: '100%' }}
      value={value || ''}
      placeholder="点击进行选择"
      onChange={val => {
        onChange(val);
      }}
      loadData={onLoadData}
      treeData={treeData}
    />
  );
};

export default SelectTree;
