import React, { useEffect, useMemo } from 'react'
import { Radio, Checkbox } from 'antd'
import './index.less'

const TileSelect = ({ value, onChange, schema }) => {

  const { presetValue, isMultiple, options, isDisable } = schema

  console.log('isDisable', schema)

  const enums = useMemo(() => {
    return options ? options.split(',') : []
  }, [options])

  const showValue = useMemo(() => {
    if (value) {
      if (isMultiple) {
        return value.split(',')
      }
      return value
    }
    return presetValue
  }, [value, presetValue, isMultiple])

  return (
    <div className='tileSelect' disabled={isDisable}>
      {
        isMultiple ?
          <Checkbox.Group
            disabled={isDisable}
            onChange={value => onChange(value.join(','))}
            value={showValue}
          >
            {enums.map(v => <Checkbox key={v} value={v}>{v}</Checkbox>)}
          </Checkbox.Group>
          :
          <Radio.Group onChange={e => onChange(e.target.value)} value={showValue} disabled={isDisable}>
            {enums.map(v => <Radio key={v} value={v}>{v}</Radio>)}
          </Radio.Group>
      }
    </div>
  )

}

export default TileSelect