import React, { useMemo } from 'react'
import { InputNumber } from 'antd'

const style = {
  width: '100%'
}

const NumberInput = ({ value, onChange, schema }) => {

  console.log('数字输入框', schema)

  const { disabled, presetValue } = schema

  const valueShow = useMemo(() => {
    return presetValue || value
  }, [presetValue, value])



  return (
    <InputNumber
      disabled={disabled}
      value={valueShow}
      onChange={value => onChange(value)}
      style={style}
    />
  )

}

export default NumberInput